<?php


	// Update order status when required
	function idealcheckout_update_order_status($aRecord, $sView)
	{
		idealcheckout_log('Updating status to "' . $aRecord['transaction_status'] . '" for order #' . $aRecord['order_id'], __FILE__, __LINE__);
		idealcheckout_log($aRecord, __FILE__, __LINE__);



		$aParams = idealcheckout_unserialize($aRecord['order_params']);
		$sCheckId = $aParams['eshop_orders_checkid'];
		$aDatabaseSettings = idealcheckout_getDatabaseSettings();

		// Update order status in database
		if(empty($aRecord['transaction_id']) == false)
		{
			if(in_array($aRecord['transaction_status'], array('SUCCESS')))
			{
				$sql = "UPDATE `" . $aDatabaseSettings['prefix'] . "eshop_orders` SET `status` = 'Pending', `transid` = '" . idealcheckout_escapeSql($aRecord['transaction_id']) . "', `edited` = NOW() WHERE (`id` = '" . idealcheckout_escapeSql($aRecord['order_id']) . "') LIMIT 1;";
				idealcheckout_database_query($sql) or die($sql . '<br>' . idealcheckout_database_error());


				// Update stock & stats
				if(isset($aParams['stock_updated']) && $aParams['stock_updated'])
				{
					// Do not update stock quantities
				}
				else
				{
					$aParams['stock_updated'] = true;

					$sql = "SELECT `item_qty`, `post_id`, `option_id`, `item_id`, `down_id` FROM `" . $aDatabaseSettings['prefix'] . "eshop_order_items` WHERE (`checkid` = '" . idealcheckout_escapeSql($sCheckId) . "') AND (`post_id` != '0');";
					$aRecordset = idealcheckout_database_query($sql) or die($sql . '<br>' . idealcheckout_database_error());

					while($aItem = idealcheckout_database_fetch_assoc($aRecordset))
					{
						if($aOrder['down_id'] != 0)
						{
							$sql = "SELECT `id`, `title`, `files` FROM `" . $aDatabaseSettings['prefix'] . "eshop_downloads` WHERE (`id` = '" . idealcheckout_escapeSql($aItem['down_id']) . "') LIMIT 1;";
							$aRecordset2 = idealcheckout_database_query($sql) or die($sql . '<br>' . idealcheckout_database_error());

							if($aDownload = idealcheckout_database_fetch_assoc($aRecordset2))
							{
								$sql = "UPDATE `" . $aDatabaseSettings['prefix'] . "eshop_downloads` SET `purchases` = (`purchases` + " . $aItem['item_qty'] . ") WHERE (`id` = '" . idealcheckout_escapeSql($aDownload['id']) . "') LIMIT 1";
								idealcheckout_database_query($sql) or die($sql . '<br>' . idealcheckout_database_error());
							}
						}

						$sql = "SELECT `id` FROM `" . $aDatabaseSettings['prefix'] . "eshop_stock` WHERE (`post_id` = '" . idealcheckout_escapeSql($aItem['post_id']) . "') AND (`option_id` = '" . idealcheckout_escapeSql($aItem['option_id']) . "') LIMIT 1;";
						$aRecordset3 = idealcheckout_database_query($sql) or die($sql . '<br>' . idealcheckout_database_error());

						if($aStock = idealcheckout_database_fetch_assoc($aRecordset3))
						{
							$sql = "UPDATE `" . $aDatabaseSettings['prefix'] . "eshop_stock` SET `purchases` = (`purchases` + " . $aItem['item_qty'] . "), `available` = (`available` - " . $aItem['item_qty'] . ") WHERE (`id` = '" . idealcheckout_escapeSql($aStock['id']) . "') LIMIT 1;";
							idealcheckout_database_query($sql) or die($sql . '<br>' . idealcheckout_database_error());
						}
						else
						{
							$sql = "INSERT INTO `" . $aDatabaseSettings['prefix'] . "eshop_stock` SET `available` = '0', `purchases` = '" . $aItem['item_qty'] . "', `post_id` = '" . idealcheckout_escapeSql($aItem['post_id']) . "', `option_id` = '" . idealcheckout_escapeSql($aItem['option_id']) . "';";
							idealcheckout_database_query($sql) or die($sql . '<br>' . idealcheckout_database_error());
						}

						// $sql = "UPDATE `" . $aDatabaseSettings['prefix'] . "eshop_base_products` SET `qty` = (`qty` - " . $aItem['item_qty'] . ") WHERE `post_id` = '" . idealcheckout_escapeSql($aItem['post_id']) . "' LIMIT 1;";
						// idealcheckout_database_query($sql) or die($sql . '<br>' . idealcheckout_database_error());
					}
				}



				// Send e-mail
				if(isset($aParams['email_customer']['send']) && ($aParams['email_customer']['send'] === false) && isset($aParams['email_customer']['to']) && isset($aParams['email_customer']['subject']) && isset($aParams['email_customer']['body']) && isset($aParams['email_customer']['headers']))
				{
					$aParams['email_customer']['send'] = true;
					mail($aParams['email_customer']['to'], $aParams['email_customer']['subject'], $aParams['email_customer']['body'], $aParams['email_customer']['headers']);
				}



				// Update affiliate info
				// ...



				// Update params
				$sql = "UPDATE `" . $aDatabaseSettings['table'] . "` SET `order_params` = '" . idealcheckout_escapeSql(idealcheckout_serialize($aParams)) . "' WHERE (`id` = '" . idealcheckout_escapeSql($aRecord['id']) . "') LIMIT 1;";
				idealcheckout_database_query($sql) or die($sql . '<br>' . idealcheckout_database_error());
			}
			else
			{
				$sql = "UPDATE `" . $aDatabaseSettings['prefix'] . "eshop_orders` SET `status` = 'Failed', `transid` = '" . idealcheckout_escapeSql($aRecord['transaction_id']) . "', `edited` = NOW() WHERE (`id` = '" . idealcheckout_escapeSql($aRecord['order_id']) . "') LIMIT 1;";
				idealcheckout_database_query($sql) or die($sql . '<br>' . idealcheckout_database_error());
			}

			// Notify webmaster
			if(isset($aParams['email_webmaster']['to']) && isset($aParams['email_webmaster']['body']) && isset($aParams['email_webmaster']['headers']) && isset($aParams['email_webmaster']['headers']))
			{
				mail($aParams['email_webmaster']['to'], ($aParams['email_webmaster']['subject'] ? $aParams['email_webmaster']['subject'] : 'Bestelling: ' . $aRecord['order_id'] . ', Status: ' . $aRecord['transaction_status']), str_replace(array('{TRANSACTION_ID}', '{TRANSACTION_STATUS}'), array($aRecord['transaction_id'], $aRecord['transaction_status']), $aParams['email_webmaster']['body']), $aParams['email_webmaster']['headers']);
			}
		}



		idealcheckout_log('Sending mail for order #' . $aRecord['order_id'], __FILE__, __LINE__);
		idealcheckout_sendMail($aRecord);
	}


?>